Dialog Subtype that represents a 'Query Dialog'. A 'Query' represents and is backed by a list of Records and a single Record definition. See Record and RecordDef.

### Hierarchy

- Dialog
  - QueryDialog

## Index

### Properties

- _scroller
- availableViews
- children
- description
- dialogClassName
- dialogMode
- domainClassName
- header
- id
- positionalQueryAbility
- recordDef
- referringObject
- selectedViewId
- sessionId
- supportsColumnStatistics
- supportsPositionalQueries
- tenantId
- type
- view
- viewMode
- BINARY_CHUNK_SIZE
- SEARCH_DIALOG_CLASS

### Accessors

- anyChildNeedsRefresh
- catavolt
- defaultActionId
- error
- hasError
- isDestroyed
- isReadViewMode
- isRefreshNeeded
- lastRefreshTime
- menu
- paneTitle
- scroller
- viewDescs

### Methods

- defaultScroller
- destroy
- findMenuAt
- formatForRead
- formatForWrite
- getProperty
- initScroller
- initialize
- invokeMenuAction
- invokeMenuActionWithId
- isBinary
- openSearch
- openView
- openViewWithId
- parseValue
- performMenuAction
- performMenuActionWithId
- propDefAtName
- query
- readLargeProperties
- readLargeProperty
- streamLargeProperty
- updateSettingsWithNewDialogProperties
- writeAttachment
- writeAttachments
- writeLargeProperties
- writeLargeProperty
- isSearchDialog
- loadLargeProperty

## Properties

### Private _scroller

_scroller: QueryScroller

- Defined in models/QueryDialog.ts:23

### availableViews

availableViews: ViewDescriptor[]

Inherited from Dialog.availableViews

- Defined in models/Dialog.ts:35

### children

children: Dialog[] = []

Inherited from Dialog.children

- Defined in models/Dialog.ts:37

### description

description: string

Inherited from Dialog.description

- Defined in models/Dialog.ts:38

### dialogClassName

dialogClassName: string

Inherited from Dialog.dialogClassName

- Defined in models/Dialog.ts:39

### dialogMode

dialogMode: DialogMode

Inherited from Dialog.dialogMode

- Defined in models/Dialog.ts:40

### domainClassName

domainClassName: string

Inherited from Dialog.domainClassName

- Defined in models/Dialog.ts:36

### header

header: View

Inherited from Dialog.header

- Defined in models/Dialog.ts:41

### id

id: string

Inherited from Dialog.id

- Defined in models/Dialog.ts:42

### positionalQueryAbility

positionalQueryAbility: PositionalQueryAbilityType

- Defined in models/QueryDialog.ts:19

### recordDef

recordDef: RecordDef

Inherited from Dialog.recordDef

- Defined in models/Dialog.ts:43

### referringObject

referringObject: ReferringObject

Inherited from Dialog.referringObject

- Defined in models/Dialog.ts:44

### selectedViewId

selectedViewId: string

Inherited from Dialog.selectedViewId

- Defined in models/Dialog.ts:45

### sessionId

sessionId: string

Inherited from Dialog.sessionId

- Defined in models/Dialog.ts:46

### supportsColumnStatistics

supportsColumnStatistics: boolean

- Defined in models/QueryDialog.ts:20

### supportsPositionalQueries

supportsPositionalQueries: boolean

- Defined in models/QueryDialog.ts:21

### tenantId

tenantId: string

Inherited from Dialog.tenantId

- Defined in models/Dialog.ts:47

### type

type: DialogType

Inherited from Dialog.type

- Defined in models/Dialog.ts:48

### view

view: View

Inherited from Dialog.view

- Defined in models/Dialog.ts:49

### viewMode

viewMode: ViewMode

Inherited from Dialog.viewMode

- Defined in models/Dialog.ts:50

### Static BINARY_CHUNK_SIZE

BINARY_CHUNK_SIZE: number = 128 * 1024

Inherited from Dialog.BINARY_CHUNK_SIZE

- Defined in models/Dialog.ts:32

### Static SEARCH_DIALOG_CLASS

SEARCH_DIALOG_CLASS: string = "SearchQueryModel"

Inherited from Dialog.SEARCH_DIALOG_CLASS

- Defined in models/Dialog.ts:31

## Accessors

### anyChildNeedsRefresh

- get anyChildNeedsRefresh(): boolean

- Inherited from Dialog.anyChildNeedsRefresh

  - Defined in models/Dialog.ts:67

  #### Returns boolean

### catavolt

- get catavolt(): CatavoltApi

- Inherited from Dialog.catavolt

  - Defined in models/Dialog.ts:63

  #### Returns CatavoltApi

### defaultActionId

- get defaultActionId(): string

- - Defined in models/QueryDialog.ts:25

  #### Returns string

### error

- get error(): DialogException

- Inherited from Dialog.error

  - Defined in models/Dialog.ts:87

  Return the error associated with this dialog, if any

  #### Returns DialogException

### hasError

- get hasError(): boolean

- Inherited from Dialog.hasError

  - Defined in models/Dialog.ts:131

  Returns whether or not this dialog loaded properly

  #### Returns boolean

### isDestroyed

- get isDestroyed(): boolean

- Inherited from Dialog.isDestroyed

  - Defined in models/Dialog.ts:139

  Returns whether or not this Form is destroyed

  #### Returns boolean

### isReadViewMode

- get isReadViewMode(): boolean

- Inherited from Dialog.isReadViewMode

  - Defined in models/Dialog.ts:151

  #### Returns boolean

### isRefreshNeeded

- get isRefreshNeeded(): boolean

- Inherited from Dialog.isRefreshNeeded

  - Defined in models/Dialog.ts:147

  Returns whether or not the data in this dialog is out of date

  #### Returns boolean

### lastRefreshTime

- get lastRefreshTime(): Date
- set lastRefreshTime(time: Date): void

- Inherited from Dialog.lastRefreshTime

  - Defined in models/Dialog.ts:159

  Get the last time this dialog's data was refreshed

  #### Returns Date

- Inherited from Dialog.lastRefreshTime

  - Defined in models/Dialog.ts:166

  Get the last time this dialog's data was refreshed

  #### Parameters

  - ##### time: Date

  #### Returns void

### menu

- get menu(): Menu

- Inherited from Dialog.menu

  - Defined in models/Dialog.ts:174

  Get the all Menu's associated with this dialog

  #### Returns Menu

### paneTitle

- get paneTitle(): string

- Inherited from Dialog.paneTitle

  - Defined in models/Dialog.ts:197

  Get the title of this dialog

  #### Returns string

### scroller

- get scroller(): QueryScroller

- - Defined in models/QueryDialog.ts:108

  Get the associated QueryScroller

  #### Returns QueryScroller

### viewDescs

- get viewDescs(): ViewDescriptor[]

- Inherited from Dialog.viewDescs

  - Defined in models/Dialog.ts:281

  Get the all ViewDescriptor's associated with this Form

  #### Returns ViewDescriptor[]

## Methods

### Private defaultScroller

- defaultScroller(): QueryScroller

- - Defined in models/QueryDialog.ts:123

  Creates a new QueryScroller with default buffer size of 50

  #### Returns QueryScroller

### destroy

- destroy(): Promise<void>

- Inherited from Dialog.destroy

  - Defined in models/Dialog.ts:77

  #### Returns Promise<void>

### findMenuAt

- findMenuAt(actionId: string): Menu

- Inherited from Dialog.findMenuAt

  - Defined in models/Dialog.ts:100

  Find a menu def on this dialog with the given actionId

  #### Parameters

  - ##### actionId: string

  #### Returns Menu

### formatForRead

- formatForRead(prop: Property, propName: string): string

- Inherited from Dialog.formatForRead

  - Defined in models/Dialog.ts:112

  Get a string representation of this property suitable for 'reading'

  #### Parameters

  - ##### prop: Property

  - ##### propName: string

  #### Returns string

### formatForWrite

- formatForWrite(prop: Property, propName: string): string

- Inherited from Dialog.formatForWrite

  - Defined in models/Dialog.ts:123

  Get a string representation of this property suitable for 'writing'

  #### Parameters

  - ##### prop: Property

  - ##### propName: string

  #### Returns string

### Protected getProperty

- getProperty(params: ReadLargePropertyParameters, propertyName: string): Promise<LargeProperty>

- Overrides Dialog.getProperty

  - Defined in models/QueryDialog.ts:115

  #### Parameters

  - ##### params: ReadLargePropertyParameters

  - ##### propertyName: string

  #### Returns Promise<LargeProperty>

### initScroller

- initScroller(pageSize: number, firstRecordId?: string, markerOptions?: QueryMarkerOption[]): void

- - Defined in models/QueryDialog.ts:29

  #### Parameters

  - ##### pageSize: number

  - ##### Default value firstRecordId: string = null

  - ##### Default value markerOptions: QueryMarkerOption[] = [QueryMarkerOption.None]

  #### Returns void

### initialize

- initialize(catavolt: CatavoltApi): void

- Inherited from Dialog.initialize

  - Defined in models/Dialog.ts:285

  #### Parameters

  - ##### catavolt: CatavoltApi

  #### Returns void

### Protected invokeMenuAction

- invokeMenuAction(menu: Menu, actionParams: ActionParameters): Promise<Redirection>

- Inherited from Dialog.invokeMenuAction

  - Defined in models/Dialog.ts:316

  Perform this action associated with the given Menu on this dialog. The targets array is expected to be an array of object ids.

  #### Parameters

  - ##### menu: Menu

  - ##### actionParams: ActionParameters

  #### Returns Promise<Redirection>

  | Redirection>}

### Protected invokeMenuActionWithId

- invokeMenuActionWithId(actionId: string, actionParams: ActionParameters): Promise<Redirection>

- Inherited from Dialog.invokeMenuActionWithId

  - Defined in models/Dialog.ts:296

  #### Parameters

  - ##### actionId: string

  - ##### actionParams: ActionParameters

  #### Returns Promise<Redirection>

### isBinary

- isBinary(column: Column): boolean

- - Defined in models/QueryDialog.ts:37

  #### Parameters

  - ##### column: Column

  #### Returns boolean

### openSearch

- openSearch(): Promise<Redirection>

- - Defined in models/QueryDialog.ts:54

  Get a redirection to the search dialog for this query dialog

  #### Returns Promise<Redirection>

### openView

- openView(targetViewDescriptor: ViewDescriptor): Promise<Dialog>

- Inherited from Dialog.openView

  - Defined in models/Dialog.ts:189

  #### Parameters

  - ##### targetViewDescriptor: ViewDescriptor

  #### Returns Promise<Dialog>

### openViewWithId

- openViewWithId(viewId: string): Promise<Dialog>

- Inherited from Dialog.openViewWithId

  - Defined in models/Dialog.ts:178

  #### Parameters

  - ##### viewId: string

  #### Returns Promise<Dialog>

### parseValue

- parseValue(formattedValue: any, propName: string): any

- Inherited from Dialog.parseValue

  - Defined in models/Dialog.ts:211

  Parses a value to prepare for 'writing' back to the server

  #### Parameters

  - ##### formattedValue: any

  - ##### propName: string

  #### Returns any

### performMenuAction

- performMenuAction(menu: Menu, targets: string[]): Promise<Redirection>

- - Defined in models/QueryDialog.ts:65

  Perform this action associated with the given Menu on this dialog. The targets array is expected to be an array of object ids.

  #### Parameters

  - ##### menu: Menu

  - ##### targets: string[]

  #### Returns Promise<Redirection>

  | Redirection>}

### performMenuActionWithId

- performMenuActionWithId(actionId: string, targets: string[]): Promise<Redirection>

- - Defined in models/QueryDialog.ts:42

  #### Parameters

  - ##### actionId: string

  - ##### targets: string[]

  #### Returns Promise<Redirection>

### propDefAtName

- propDefAtName(propName: string): PropertyDef

- Inherited from Dialog.propDefAtName

  - Defined in models/Dialog.ts:220

  Get the property definition for a property name

  #### Parameters

  - ##### propName: string

  #### Returns PropertyDef

### query

- query(maxRows: number, direction: QueryDirection, fromRecordId: string): Promise<RecordSet>

- - Defined in models/QueryDialog.ts:82

  Perform a query

  #### Parameters

  - ##### maxRows: number

  - ##### direction: QueryDirection

  - ##### fromRecordId: string

  #### Returns Promise<RecordSet>

### readLargeProperties

- readLargeProperties(recordId: string): Promise<LargeProperty[]>

- Inherited from Dialog.readLargeProperties

  - Defined in models/Dialog.ts:230

  Read all the large property values into memory in this Record

  #### Parameters

  - ##### recordId: string

  #### Returns Promise<LargeProperty[]>

### readLargeProperty

- readLargeProperty(propertyName: string, recordId?: string): Promise<LargeProperty>

- Inherited from Dialog.readLargeProperty

  - Defined in models/Dialog.ts:249

  Read a large property into memory

  #### Parameters

  - ##### propertyName: string

  - ##### Optional recordId: string

  #### Returns Promise<LargeProperty>

### streamLargeProperty

- streamLargeProperty(streamConsumer: StreamConsumer, propertyName: string, recordId?: string): Promise<LargeProperty>

- Inherited from Dialog.streamLargeProperty

  - Defined in models/Dialog.ts:263

  Stream the encoded chunks of a large property without retaining them The streamConsumer will receive Base64 encoded chunks with callbacks. hasMore will be false with the final chunk.

  #### Parameters

  - ##### streamConsumer: StreamConsumer

  - ##### propertyName: string

  - ##### Optional recordId: string

  #### Returns Promise<LargeProperty>

### Protected updateSettingsWithNewDialogProperties

- updateSettingsWithNewDialogProperties(referringObject: ReferringObject): void

- Inherited from Dialog.updateSettingsWithNewDialogProperties

  - Defined in models/Dialog.ts:320

  #### Parameters

  - ##### referringObject: ReferringObject

  #### Returns void

### Protected writeAttachment

- writeAttachment(attachment: Attachment): Promise<void>

- Inherited from Dialog.writeAttachment

  - Defined in models/Dialog.ts:337

  #### Parameters

  - ##### attachment: Attachment

  #### Returns Promise<void>

### Protected writeAttachments

- writeAttachments(record: Record): Promise<void[]>

- Inherited from Dialog.writeAttachments

  - Defined in models/Dialog.ts:344

  #### Parameters

  - ##### record: Record

  #### Returns Promise<void[]>

### Protected writeLargeProperties

- writeLargeProperties(record: Record): Promise<void[]>

- Inherited from Dialog.writeLargeProperties

  - Defined in models/Dialog.ts:363

  Write all Binary values in this Record back to the server

  #### Parameters

  - ##### record: Record

  #### Returns Promise<void[]>

### Protected writeLargeProperty

- writeLargeProperty(propertyName: string, largeProperty: LargeProperty): Promise<void>

- Inherited from Dialog.writeLargeProperty

  - Defined in models/Dialog.ts:375

  #### Parameters

  - ##### propertyName: string

  - ##### largeProperty: LargeProperty

  #### Returns Promise<void>

### Static isSearchDialog

- isSearchDialog(dialog: any): boolean

- Inherited from Dialog.isSearchDialog

  - Defined in models/Dialog.ts:58

  #### Parameters

  - ##### dialog: any

  #### Returns boolean

### Static loadLargeProperty

- loadLargeProperty(getPropertyFn: function, streamConsumer?: StreamConsumer, propertyName?: string, recordId?: string): Promise<LargeProperty>

- Inherited from Dialog.loadLargeProperty

  - Defined in models/Dialog.ts:449

  Read a large property into memory or stream it, if a streamConsumer is provided The actual service call that retrieves the result is delegate to the 'getPropertyFn'

  #### Parameters

  - ##### getPropertyFn: function

    - - (params: ReadLargePropertyParameters, propertyName?: string): Promise<LargeProperty>

      - #### Parameters

        - ##### params: ReadLargePropertyParameters

        - ##### Optional propertyName: string

        #### Returns Promise<LargeProperty>

  - ##### Optional streamConsumer: StreamConsumer

  - ##### Optional propertyName: string

  - ##### Optional recordId: string

  #### Returns Promise<LargeProperty>

Generated using TypeDoc